/*
** list_merge.c for list in /u/a1/deleda_c/rendu/piscine/j6/list
**
** Made by charles-alban deledalle
** Login   <deleda_c@epita.fr>
**
** Started on  Sat Sep 17 01:47:31 2005 charles-alban deledalle
** Last update Sat Sep 17 03:07:39 2005 charles-alban deledalle
*/

#include <stdlib.h>
#include <stdio.h>
#include "s_list.h"

void		list_merge(struct s_list	**list_a,
			   struct s_list	*list_b,
			   t_cmp_func		cmp_func);

static void	insert_and_next(struct s_list	**list_a,
				struct s_list	*list_b,
				t_cmp_func	cmp_func)
{
  struct s_list	*p;

  p = list_b->next;
  list_b->next = *list_a;
  *list_a = list_b;
  list_merge(list_a, p, cmp_func);
}

void		list_merge(struct s_list	**list_a,
			   struct s_list	*list_b,
			   t_cmp_func		cmp_func)
{
  if (list_b)
    {
      if (!(*list_a))
	insert_and_next(list_a, list_b, cmp_func);
      else
	if (cmp_func((*list_a)->data, list_b->data) >= 0)
	  insert_and_next(list_a, list_b, cmp_func);
	else
	  list_merge(&((*list_a)->next), list_b, cmp_func);
    }
}
